/*
Engine.cpp
Written by Matthew Fisher

See Engine.h for a defintion of all files included here.
*/

//All source files include Main.h
#include "Main.h"

#include "Engine\Core\Stdhdr.cpp"
#include "Engine\Core\UnicodeString.cpp"
#include "Engine\Core\String.cpp"
#include "Engine\Core\OutputDataStream.cpp"
#include "Engine\Core\InputDataStream.cpp"
#include "Engine\Core\Compression.cpp"

#include "Engine\Networking\Pipe.cpp"

#include "Engine\Math\RGBColor.cpp"
#include "Engine\Math\SpaceVector.cpp"
#include "Engine\Math\Line3D.cpp"
#include "Engine\Math\LineSegment2D.cpp"
#include "Engine\Math\LineSegment3D.cpp"
#include "Engine\Math\Plane.cpp"
#include "Engine\Math\Intersect.cpp"
#include "Engine\Math\Matrix4.cpp"
#include "Engine\Math\Distance.cpp"

#include "Engine\Multithreading\Thread.cpp"

#include "Engine\Audio\AudioDevice.cpp"
#include "Engine\Audio\WaveFile.cpp"
#include "Engine\Audio\WaveFileReader.cpp"

#include "Engine\Graphics Objects\Bitmap.cpp"
#include "Engine\Graphics Objects\MatrixController.cpp"
#include "Engine\Graphics Objects\Camera.cpp"
#include "Engine\Graphics Objects\PrimitiveRender.cpp"
#include "Engine\Graphics Objects\MeshVertex.cpp"
#include "Engine\Graphics Objects\KDTree3.cpp"
#include "Engine\Graphics Objects\KDTreeN.cpp"
#include "Engine\Graphics Objects\PointSet.cpp"
#include "Engine\Graphics Objects\RayIntersectorBruteForce.cpp"
#include "Engine\Graphics Objects\RayIntersectorKDTree.cpp"

#include "Engine\Simple Mesh\BaseMesh.cpp"
#include "Engine\Simple Mesh\D3D9Mesh.cpp"
#include "Engine\Simple Mesh\D3D10Mesh.cpp"
#include "Engine\Simple Mesh\Mesh.cpp"

#include "Engine\Complex Mesh\Triangle.cpp"
#include "Engine\Complex Mesh\FullEdge.cpp"
#include "Engine\Complex Mesh\Vertex.cpp"
#include "Engine\Complex Mesh\ComplexMesh.cpp"

#include "Engine\D3D9 Objects\D3D9RenderTargetTexture.cpp"
#include "Engine\D3D9 Objects\D3D9RenderTargetSurface.cpp"
#include "Engine\D3D9 Objects\D3D9VertexDeclaration.cpp"
#include "Engine\D3D9 Objects\D3D9PixelShader.cpp"
#include "Engine\D3D9 Objects\D3D9VertexShader.cpp"
#include "Engine\D3D9 Objects\D3D9PersistentMesh.cpp"
#include "Engine\D3D9 Objects\D3D9Font.cpp"
#include "Engine\D3D9 Objects\D3D9Texture.cpp"
#include "Engine\D3D9 Objects\D3D9Primitives.cpp"

#include "Engine\Graphics Devices\GraphicsDevice.cpp"
#include "Engine\Graphics Devices\D3D9GraphicsDevice.cpp"

#include "Engine\Utility\MovieExporter.cpp"
#include "Engine\Utility\AudioCapture.cpp"
#include "Engine\Utility\VideoCompressor.cpp"
#include "Engine\Utility\FileCollection.cpp"
#include "Engine\Utility\ParameterFile.cpp"
#include "Engine\Utility\FrameTimer.cpp"
#include "Engine\Utility\Profiler.cpp"
#include "Engine\Utility\Directory.cpp"
#include "Engine\Utility\MenuInterface.cpp"
#include "Engine\Utility\Console.cpp"

#include "Engine\Windows Controller\ApplicationWindow.cpp"
#include "Engine\Windows Controller\InputManager.cpp"
#include "Engine\Windows Controller\EventHandler.cpp"
#include "Engine\Windows Controller\WinMain.cpp"
